<template>
  <BasicModal v-bind="$attrs" @register="registerModal" :title="title" @ok="handleSubmit" width="60%">
    <BasicForm @register="registerForm" />
  </BasicModal>
</template>

<script lang="ts" setup>
  import { ref, computed, unref } from 'vue';
  import { BasicModal, useModalInner } from '/@/components/Modal';
  import { BasicForm, useForm } from '/@/components/Form/index';
  import { encryptData } from '/@/api/common/api';
  import { formSchema } from '../GZjcyb.data';
  import { saveOrUpdate } from '../GZjcyb.api';
  import { decrypts } from '@/utils/checkTip';
  // Emits声明
  const emit = defineEmits(['register', 'success']);
  const isUpdate = ref(true);
  //表单配置
  const [registerForm, { resetFields, setFieldsValue, validate }] = useForm({
    rowProps: { gutter: 24, justify: 'start', align: 'middle' },
    //全局col列占比(每列显示多少位)，和schemas中的colProps属性一致
    baseColProps: { span: 12 },
    //使用labelCol的样式参数来控制标题宽度
    labelCol: { style: { width: '150px' } },
    //row行的样式
    baseRowStyle: { width: '100%' },
    //表单布局属性，支持（vertical,horizontal），默认为horizontal
    layout: 'horizontal',
    schemas: formSchema,
    showActionButtonGroup: false,
  });
  //表单赋值
  const [registerModal, { setModalProps, closeModal }] = useModalInner(async (data) => {
    //重置表单
    await resetFields();
    setModalProps({ confirmLoading: false, showCancelBtn: data?.showFooter, showOkBtn: data?.showFooter });
    isUpdate.value = !!data?.isUpdate;
    if (unref(isUpdate)) {
      if (data.record.sfzh) data.record.sfzh = await decrypts(data.record.sfzh, false);
      // if (data.record.lxdh) data.record.lxdh = await decrypts(data.record.lxdh, false);
      if (data.record.yhzh) data.record.yhzh = await decrypts(data.record.yhzh, false);
      // 如果是详情
      if (!data?.showFooter) {
        data.record.showFooter = true; //查看要禁用
        if (data.record.sfzh) data.record.sfzh = await decrypts(data.record.sfzh, true);
        // if (data.record.lxdh) data.record.lxdh = await decrypts(data.record.lxdh, true);
        if (data.record.yhzh) data.record.yhzh = await decrypts(data.record.yhzh, true);
      }
      //表单赋值
      await setFieldsValue({
        ...data.record,
      });
    }
  });

  // 解密
  // async function decrypts(v) {
  //   console.log(v, 'v');
  //   if (!v) return;
  //   let res = v;
  //   let str;
  //   if (res.length == 11) {
  //     str = res.replace(res.substring(3, 7), '****');
  //   } else if (res.length > 11 && res.length < 18) {
  //     if (/^(0\d{3}-\d{7})|(0\d{2}-\d{8})$/.test(res)) {
  //       str = res.replace(/\d(?=\d{3,}$)/g, '*');
  //     } else str = res.replace(/\d{4}(\d{10}|\d{8})(\d{4})/, '****$1****');
  //   } else if (res.length == 18) {
  //     str = res.replace(/(\d{6})\d+(\d{4})/, '$1******$2');
  //   } else str = res.replace(/^(.{4})(?:\d+)(.{4})$/, '$1 **** **** $2');

  //   return str;
  // }
  //设置标题
  const title = computed(() => (!unref(isUpdate) ? '新增' : '编辑'));
  //表单提交事件
  async function handleSubmit() {
    try {
      let values = await validate();
      values.sfzh = await encryptData({ str: values.sfzh });
      // values.lxdh = await encryptData({ str: values.lxdh });
      values.yhzh = await encryptData({ str: values.yhzh });
      setModalProps({ confirmLoading: true });
      //提交表单
      await saveOrUpdate(values, isUpdate.value);
      //关闭弹窗
      closeModal();
      //刷新列表
      emit('success', { isUpdate: isUpdate.value, values });
    } finally {
      setModalProps({ confirmLoading: false });
    }
  }
</script>

<style scoped>
  /** 时间和数字输入框样式 */
  :deep(.ant-input-number) {
    width: 100%;
  }
</style>
